d("customPDPView",['ccrz', 'util', 'tabSectionView'], function(CCRZ, UTIL, tabSectionView) {

    var runDefaultJsFunctions = function(){
        initTooltip();
        initCustomForms();
        businessLayout();
        initCustomLabel();
        initRetinaCover();
        initCustomHover();
        runHandleBarJsHelpers();
    }

    return {
        staticResourceUrls: {
            egressTheme: ''
        },
        runDefaultJs: function(){
            setTimeout(() => {
                runDefaultJsFunctions();
            }, 500);
        },
        extendCustomPDPView: function() {
            CCRZ.custom = _.extend(CCRZ.custom||{}); 
            CCRZ.custom.views = _.extend(CCRZ.custom.views||{}); 
            CCRZ.custom.models = _.extend(CCRZ.custom.models||{}); 
            CCRZ.remoteActions = _.extend(CCRZ.remoteActions||{}); 
            setTimeout(() => {
                runDefaultJsFunctions();
            }, 500);
            let isRefreshed = false, isBackward = false;
            let isReprint = (CCRZ.pagevars.queryParams.isReprint == 'true'?true:false);
            CCRZ.pubSub.on('view:cartView:refresh', function(cartView){
                cartView.renderDesktop = function(){
                    let view = this;
                    view.setElement($(CCRZ.uiProperties.miniCartView.desktop.selector));
                    view.$el.html(view.templateDesktop(view.cartmodel.toJSON()));
                    CCRZ.prodDetailView.model.set('cartItems', CCRZ.cartView.cartmodel);
                    if(CCRZ.cartView.cartmodel.attributes.cartItemCount > 0){
                        UTIL.calculateSubscriptionPrices(view.cartmodel.get('cartItems'), CCRZ.prodDetailView, 'review');
                    }
                    if(!isReprint){
                        CCRZ.prodDetailView.render();
                    }
                }
                cartView.delegateEvents();
            });
            CCRZ.pubSub.on('view:productDetailView:refresh', function(detailView){
                if(!isRefreshed){
                    CCRZ.remoteActions.pdpRemoting =  _.extend(CCRZ.RemoteInvocation,{ 
                        className : 'DCMB2B_pdp_Controller', 
                        addToCart : function( reqData,callback){ 
                            this.invokeCtx('addToCartExtension', 
                                reqData,  
                                function(resp, evt){ 
                                    if(callback){
                                        callback(resp,evt);
                                    }            
                                }, 
                                { 
                                    buffer:false, 
                                    nmsp : false 
                                } 
                            );
                        },
                        getCartDataBySku: function( reqData,callback){ 
                            this.invokeCtx('getCartDataBySku', 
                                reqData,  
                                function(resp, evt){ 
                                    if(callback){
                                        callback(resp,evt);
                                    }            
                                }, 
                                { 
                                    buffer:false, 
                                    nmsp : false 
                                } 
                            );
                        }
                    });
                    setTimeout(function(){
                        CCRZ.prodDetailView.model.set('cartItems', CCRZ.cartView.cartmodel);
                        if(CCRZ.cartView.cartmodel.attributes.cartItemCount > 0){
                            UTIL.calculateSubscriptionPrices(CCRZ.cartView.cartmodel.get('cartItems'), CCRZ.prodDetailView, 'review');
                        }
                        if(!isReprint){
                            detailView.render();
                        }
                    }, 1500);
                    let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                    let quantity = 1, frequencyTerm = (isReprint?'One-Time':'Monthly'), loaderTimeout = 500;
                    let sptType = (isReprint?'': (CCRZ.pagevars.isGuest?'':detailView.model.attributes.subProdTerms[0].KFB2BSptType));
                    let frequencyTermId = '', isPriceError = false;
                    if(!CCRZ.pagevars.isGuest){
                        detailView.model.attributes.subProdTerms.forEach(function(spt){
                            if(isReprint){
                                if(spt.KFB2BSptType == 'Reprint'){
                                    frequencyTermId = (frequencyTermId == ''?spt.sfid:frequencyTermId);
                                }
                            } else {
                                if(spt.KFB2BSptType != 'Reprint'){
                                    frequencyTermId = (frequencyTermId == ''?spt.sfid:frequencyTermId);
                                }
                            }
                        });
                    }
                    
                    if(frequencyTermId == '' && !CCRZ.pagevars.isGuest){
                        isPriceError = true;
                    }
                    let currentDate = new Date(), minDate = 3;
                    currentDate.setDate(currentDate.getDate() + minDate);
                    if(currentDate.getDay() == 6){
                        currentDate.setDate(currentDate.getDate() + 2);
                        minDate = minDate + 2;
                    } else if(currentDate.getDay() == 0){
                        currentDate.setDate(currentDate.getDate() + 1);
                        minDate = minDate + 1;
                    }
                    let imageList = [];
                    if(!isReprint){
                        let media = detailView.model.attributes.mediaWrappers;
                        for(let key in media){
                            if(key == "Alternate Images" || key == 'Product Image'){
                                let tempList = imageList.concat(media[key]);
                                imageList = tempList;
                            }
                        }
                    }
                    imageList.reverse();
                    detailView.model.set('startDate', currentDate);
                    detailView.model.set('minDate', 0);
                    detailView.model.set('sptType', sptType);
                    detailView.model.set('isReprint', isReprint);
                    detailView.model.set('frequencyTerm', frequencyTerm);
                    detailView.model.set('frequencyTermId', frequencyTermId);
                    detailView.model.set('isPriceError', isPriceError);
                    detailView.model.set('isSubCatAvailable', true);
                    detailView.model.set('imageList', imageList);
                    // prep data for tab sections authors and characters
                    setTabSectionData(detailView);
                    if(detailView.model.attributes.subProdTerms ){
                        UTIL.validateDisplayName(detailView.model.attributes.subProdTerms[0], detailView);
                    }
                    detailView.model.set('quantity', quantity);
                    if(ProductType == "Aggregated"){
                        let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                        if(compositeProds && compositeProds.length > 0){
                            compositeProds.forEach(function(prod, index){
                                prod['isChecked'] = (index == 0?true:false);
                            });
                        }
                    }
                    if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                        calculateBundlePrice(detailView);
                    } else {
                        calculateProductPrice(detailView, false);
                    }
                    detailView.events["click .add_to_cart_button"]  = "clickedOnAddToCart";
                    detailView.events["click .buy_now_button"]  = "clickedOnAddToCart";
                    detailView.events["click .add_bolt_on_button"] = "clickedOnAddBoltOn";
                    detailView.events["click .jcf-btn-inc"]  = "onProductQuantityChange";
                    detailView.events["click .jcf-btn-dec"]  = "onProductQuantityChange";
                    detailView.events["click .productName"]  = "gotoProductDetail";
                    detailView.events["click .quantityContainer .compositePlus"]  = "onHandleCompositeProducts";
                    detailView.events["change .quantityContainer .quantity"]  = "onHandleCompositeProducts";
                    detailView.events["click .quantityContainer .compositeMinus"]  = "onHandleCompositeProducts";
                    detailView.events["keypress #product_quantity"] = "validateCartQuantity";
                    detailView.events["change #product_quantity"]  = "onProductQuantityChange";
                    detailView.events["change .composite_product_select"]  = "onCompositeProductChange";
                    detailView.events["change .category_select"]  = "onCategoryChange";
                    detailView.events["change .spt-radio"]  = "onSptRadioChange";
                    detailView.events["change .subCategory_select"]  = "onSubCategoryChange";
                    detailView.events["click .addOnPDP"] = 'onClickAddOnPDP'
                    detailView.events["click #includedItems"] = 'onHandleIncludedItems';
                    detailView.events["change #datePickerPDP"] = "handleDateChange";
                    detailView.events['click .mainImagePDP'] = 'handleOpenImageModal';
                    detailView.events['click .subscribeProduct'] = 'handleSubscribeModal';
                    detailView.events['click .printComic'] = 'handleOpenPrintModal';
                    detailView.events['click .createLead'] = 'handleCreateLead';
                    detailView.events['click .carousel-indicators li'] = 'slideToPromo';
                    detailView.events['click .createLeadAccredit'] = 'handleCreateLeadAccredit';
                    detailView.events['click .callToActionBtn'] = 'handleCallToActionModal';
                    detailView.events['click .createLeadCallToAction'] = 'handleCreateLeadCallToAction';
                    detailView.events['click .goToLogin'] = 'openLoginModal';
                    // Overriding the render Section to call the custom view for tabSection
                    detailView.renderSections = function() {
                        for (var i=0; i<CCRZ.pageSectionsList.length; i++) {
                         var mod = CCRZ.pageSectionsList.at(i);
                         if (mod.attributes.displayType === 'Tab') {
                          var tabView = new tabSectionView(mod, this.model);
                          tabView.render();
                          for (var j=0; j<mod.attributes.subSections.length; j++) {
                           this.buildViewForSection(mod.attributes.subSections[j]);
                          }
                         }
                         else if (mod.attributes.displayType === 'Widget') {
                          var widgetView = new CCRZ.views.widgetSectionView(mod, this.model);
                          widgetView.render();
                          this.buildViewForSection(mod.toJSON());
                         }
                        }
                    };
                    detailView.openLoginModal = function(){
                        CCRZ.menuView.openLoginModal();
                    };
                    detailView.handleOpenImageModal = function(event){
                        event.preventDefault();
                        $('#imageModal .pdpImage').attr('src', event.target.src);
                        $('#imageModal').modal({backdrop: true, show: true}); 
                        $('#imageModal').removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    };
                    detailView.handleSubscribeModal = function(event){
                        event.preventDefault();
                        $('#subscribeModal').modal({backdrop: true, show: true}); 
                        $('#subscribeModal').removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    };
                    detailView.handleOpenPrintModal = function(event){
                        event.preventDefault();
                        $('#printModal').modal({backdrop: true, show: true}); 
                        $('#printModal').removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    };
                    detailView.handleCallToActionModal = function(event){
                        event.preventDefault();
                        $('#callToActionModal').modal({backdrop: true, show: true}); 
                        $('#callToActionModal').removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    };
                    detailView.doCarousel = function(){
                        $('.carousel-inner .item:first-child').addClass('active');
                        $('.carousel-indicators li:first-child').addClass('active');
                   
                        $('#splashCarousel').on('slid', function(event) {
                            var idx = $('.carousel-inner .active').data('id');
                            $('.carousel-indicators li').removeClass('active');
                            $('.carousel-indicators li[data-slide-to="' + idx + '"]').addClass("active");
                        });
                        $('.carousel').carousel();
                    };
                    detailView.slideToPromo = function(event){
                        var idx = event.target.dataset.slideTo;
                        $('#splashCarousel').carousel(idx);
                        $('.carousel-indicators li').removeClass('active');
                        $('.carousel-indicators li[data-slide-to="' + idx + '"]').addClass("active");
                    };
                    detailView.initValidationDesktop = function(formName) {
                        jQuery(formName).validate({
                         invalidHandler : function(event, validator) {
                          if(!CCRZ.disableAdaptive) {
                           CCRZ.handleValidationErrors(event, validator, 'error_messages_section', false);
                          }
                         },
                         rules : {
                            firstName       : { required : true, lettersonly: true},
                            lastName       : { required : true, lettersonly: true},
                            phone      : { required : true, digits : true},
                            email       : { required : true, email: true},
                            company       : { required : true },
                            city      : { required : false, lettersonly: true},
                            stateZip      : { required : false, maxlength: 10, minlength: 5, digits : true},
                          companyName      : { required : true },
                          companyPhone      : { required : true },
                          website      : { required : true, url : true},
                          sundayCirculation      : { required : true },
                          dailyCirculation      : { required : true },
                          monthlyVisitors      : { required : true }
                         },
                         messages : {
                            firstName       : { required : CCRZ.pagevars.pageLabels['SR_FNameRequired'], lettersonly: CCRZ.processPageLabelMap('KFB2B_PDP_onlyAlphaError').toString()},
                            lastName       : { required : CCRZ.pagevars.pageLabels['SR_LNameRequired'], lettersonly: CCRZ.processPageLabelMap('KFB2B_PDP_onlyAlphaError').toString()},
                            phone      : { required : CCRZ.pagevars.pageLabels['SR_PhoneRequired'], digits : CCRZ.processPageLabelMap('KFB2B_PDP_onlyNumbersError').toString()},
                            company      : { required : CCRZ.pagevars.pageLabels['SR_CompanyNameRequired']},
                            email       : { required : CCRZ.processPageLabelMap('KFB2B_PDP_emailReqError').toString(), email : CCRZ.processPageLabelMap('KFB2B_PDP_emailFormatError').toString()},
                            city        : { required : CCRZ.processPageLabelMap('KFB2B_PDP_cityReqError').toString(), lettersonly: CCRZ.processPageLabelMap('KFB2B_PDP_onlyAlphaError').toString()},
                            stateZip    : { required : CCRZ.processPageLabelMap('KFB2B_PDP_zipReqError').toString()
                                            , minlength : CCRZ.processPageLabelMap('KFB2B_PDP_zipMinError').toString()
                                            , maxlength : CCRZ.processPageLabelMap('KFB2B_PDP_zipMaxError').toString()
                                            , digits : CCRZ.processPageLabelMap('KFB2B_PDP_onlyNumbersError').toString()},
                          companyName      : { required : CCRZ.pagevars.pageLabels['SR_CompanyNameRequired'] },
                          companyPhone      : { required : CCRZ.processPageLabelMap('KFB2B_PDP_phoneReqError').toString() },
                          website      : { required : CCRZ.processPageLabelMap('KFB2B_PDP_websiteReqError').toString(), url : CCRZ.processPageLabelMap('KFB2B_PDP_websiteValidURL').toString()},
                          sundayCirculation      : { required : CCRZ.processPageLabelMap('KFB2B_PDP_sundayReqError').toString() },
                          dailyCirculation      : { required : CCRZ.processPageLabelMap('KFB2B_PDP_dailyReqError').toString() },
                          monthlyVisitors      : { required : CCRZ.processPageLabelMap('KFB2B_PDP_monthlyReqError').toString() }
                         },
                         errorElement: "em",
                         errorPlacement: function ( error, element ) {
                          // Needed for bootstrap 3 (per validator documentation)
                          if(CCRZ.disableAdaptive) {
                           error.addClass( "help-block" );
                    
                           if ( element.prop( "type" ) === "checkbox" ) {
                            error.insertAfter( element.parent( "label" ) );
                           } else {
                            error.insertAfter( element );
                           }
                          }
                         },
                         highlight: function ( element, errorClass, validClass ) {
                          if(CCRZ.disableAdaptive) {
                           $(element).parents(".col-sm-4").addClass("has-error").removeClass("has-success");
                          }
                         },
                         unhighlight: function (element, errorClass, validClass) {
                          if(CCRZ.disableAdaptive) {
                           $(element).parents(".col-sm-4").addClass("has-success").removeClass("has-error");
                          }
                         }
                        });
                    };
                    detailView.handleCreateLeadCallToAction = function(event){
                        if (jQuery('#callToActionForm').valid()) {
                            let _this = this;
                            let callToActionJSON = jQuery('#callToActionForm').serializeObject();
                            callToActionJSON['type'] = 'callToAction';
                            callToActionJSON['emailOptIn'] = $('#emailOpt').is(':checked');
                            UTIL.showLoader();
                            CCRZ.remoteModel.createLead(JSON.stringify(callToActionJSON), function(res, evt){
                                if(res && res.success && res.data){
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-ctaModal-Info", CCRZ.processPageLabelMap('KFB2B_PDP_successRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-ctaModal-Info').css('display', 'none');
                                        $('.acc_subject').val('');
                                        $('.acc_description').val('');
                                        $('.close').click();
                                    }, 3000);
                                } else {
                                    // Error Handling
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-ctaModal-Error", CCRZ.processPageLabelMap('KFB2B_PDP_errorRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-ctaModal-Error').css('display', 'none');
                                    }, 3000);
                                }
                                UTIL.hideLoader();
                            });
                        } else {
                            let message = CCRZ.processPageLabelMap('KFB2B_PDP_fillAllFields').toString();
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-ctaModal-Error", message));
                            setTimeout(function(){
                                $('.messagingSection-ctaModal-Error').css('display', 'none');
                            }, 3000);
                        }
                    };
                    detailView.handleCreateLeadAccredit = function(event){
                        if (jQuery('#newCustomerForm').valid() && $('#tcCheck').is(':checked')) {
                            let _this = this;
                            let newCustomerJSON = jQuery('#newCustomerForm').serializeObject();
                            newCustomerJSON['type'] = 'accredit';
                            UTIL.showLoader();
                            CCRZ.remoteModel.createLead(JSON.stringify(newCustomerJSON), function(res, evt){
                                if(res && res.success && res.data){
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-subModal-Info", CCRZ.processPageLabelMap('KFB2B_PDP_notifiedInfo').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-subModal-Info').css('display', 'none');
                                        $('.acc_subject').val('');
                                        $('.acc_description').val('');
                                        $('.close').click();
                                    }, 3000);
                                } else {
                                    // Error Handling
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-subModal-Error", CCRZ.processPageLabelMap('KFB2B_PDP_errorRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-subModal-Error').css('display', 'none');
                                    }, 3000);
                                }
                                UTIL.hideLoader();
                            });
                        } else {
                            let message = CCRZ.processPageLabelMap('KFB2B_PDP_fillAllFields').toString();
                            if(!$('#tcCheck').is(':checked')){
                                message = 'Please check T&C before proceeding!';
                            }
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-subModal-Error", message));
                            setTimeout(function(){
                                $('.messagingSection-subModal-Error').css('display', 'none');
                            }, 3000);
                        }
                    };
                    detailView.handleCreateLead = function(event){
                        if(($('.acc_subject').val()).trim() != '' && ($('.acc_description').val()).trim() != ''){
                            let reqData = {
                                'type' : 'update',
                                'subject' : $('.acc_subject').val(),
                                'description' : $('.acc_description').val()
                            };
                            CCRZ.remoteModel.createLead(JSON.stringify(reqData), function(res, evt){
                                if(res && res.success && res.data){
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-accModal-Info", CCRZ.processPageLabelMap('KFB2B_PDP_successRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-accModal-Info').css('display', 'none');
                                        $('.acc_subject').val('');
                                        $('.acc_description').val('');
                                        $('.close').click();
                                    }, 3000);
                                } else {
                                    // Error Handling
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-accModal-Error", CCRZ.processPageLabelMap('KFB2B_PDP_errorRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-accModal-Error').css('display', 'none');
                                    }, 3000);
                                }
                            });
                        } else {
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-accModal-Error", CCRZ.processPageLabelMap('KFB2B_PDP_allFieldsRequired').toString()));
                            setTimeout(function(){
                                $('.messagingSection-accModal-Error').css('display', 'none');
                            }, 3000);
                        }
                    };
                    detailView.onHandleIncludedItems = function(event){
                        let sku = event.currentTarget.dataset.sku;
                        this.model.set('selectedSku', sku);
                        this.render();
                        setTimeout(() => {
                            runDefaultJsFunctions();
                            $('#bundleFlow').modal({backdrop: true, show: true}); 
                            $('#bundleFlow').removeClass('fade');
                        }, 300);
                    };
                    detailView.onCompositeChange = function(event){
                        UTIL.showLoader();
                        let id = event.target.value;
                        let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                        if(ProductType == "Aggregated"){
                            let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                            if(compositeProds && compositeProds.length > 0){
                                compositeProds.forEach(function(prod, index){
                                    prod['isChecked'] = (id == prod.componentR.sfid?true:false);
                                });
                            }
                        }
                        calculateProductPrice(detailView, true);
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.onHandleCompositeProducts = function(event){
                        let sku = event.currentTarget.dataset.sku, type= event.currentTarget.dataset.type, quantity = parseInt($('#quantity_' + sku).text());
                        quantity = (type=='inc'?(quantity+1):(type=='dec'?(quantity>0?quantity-1:quantity):quantity));
                        detailView.model.attributes.product.prodBean.compositeProductsS.forEach(function(product){
                            if(sku == product.componentR.SKU){
                                product.quantity = quantity;
                            }
                        });
                        if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                            calculateBundlePrice(detailView);
                        } else {
                            calculateProductPrice(detailView, true);
                        }
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.handleDateChange = function(event){
                        detailView.model.set('startDate', new Date(event.target.value));
                    };
                    detailView.onSptRadioChange = function(event){
                        UTIL.showLoader();
                        detailView.model.set('frequencyTermId', event.target.dataset.id);
                        if(detailView.model.attributes.product.prodBean.isSubscriptionAvailable){
                            CCRZ.productDetailModel.attributes.subProdTerms.forEach(function(item){
                                if(item.sfid == event.target.dataset.id){
                                    detailView.model.set('frequencyTerm', item.installmentFrequencyUOM);
                                    UTIL.validateDisplayName(item, detailView);
                                } else if(event.target.dataset.id == ''){
                                    detailView.model.set('frequencyTerm', 'One-Time');
                                }
                            });
                        }
                        if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                            calculateBundlePrice(detailView);
                        } else {
                            calculateProductPrice(detailView, true);
                        }
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.onCategoryChange = function(event){
                        //UTIL.showLoader();
                        let subCategoryMap = detailView.model.get('reprintSubCatMap');
                        if(event.target.value == ''){
                            detailView.model.set('isNASelection', true);
                        } else {
                            detailView.model.set('isNASelection', false);
                        }
                        detailView.model.set('selectedCategory', event.target.value);
                        let subCategoryList = subCategoryMap[event.target.value], isSubCatAvailable = false;
                        if(detailView.model.attributes.product.prodBean.isSubscriptionAvailable){
                            CCRZ.productDetailModel.attributes.subProdTerms.forEach(function(item){
                                if(item.KFB2BSptType == 'Reprint' && !_.isUndefined(item.reprintPricing) && item.reprintPricing.length > 0){
                                    item.reprintPricing.forEach(function(category){
                                        if(category.name == event.target.value){
                                            detailView.model.set('frequencyTermId', item.sfid);
                                            if(typeof category.value == 'object'){
                                                detailView.model.set('reprintSubCategory', subCategoryList);
                                                detailView.model.set('selectedSubCategory', subCategoryList[0]);
                                                subCategoryPriceUpdate(detailView, subCategoryList[0]);
                                                isSubCatAvailable = true;
                                            } else {
                                                detailView.model.set('selectedSubCategory', '');
                                                detailView.model.set('reprintSubCategory', []);
                                                detailView.model.set('productPrice', category.value);
                                                detailView.model.set('displayName', UTIL.formatCurrency(category.value));
                                                isSubCatAvailable = true;
                                                detailView.render();
                                            }
                                        }
                                    });
                                }
                            });
                            detailView.model.set('isSubCatAvailable', isSubCatAvailable);
                            if(!isSubCatAvailable){
                                detailView.render();
                            }
                        }
                    };
                    detailView.onSubCategoryChange = function(event){
                        //UTIL.showLoader();
                        detailView.model.set('selectedSubCategory', event.target.value);
                        subCategoryPriceUpdate(detailView, event.target.value);
                    };
                    detailView.onClickAddOnPDP = function(event){
                        UTIL.showLoader();
                        let isChecked = event.target.checked, relatedId = event.currentTarget.dataset.id;
                        if(detailView.model.attributes.relatedProducts.Accessories && detailView.model.attributes.relatedProducts.Accessories.length > 0){
                            detailView.model.attributes.relatedProducts.Accessories.forEach(function(related){
                                if(relatedId == related.prodBean.sfid){
                                    related.prodBean['isChecked'] = isChecked;
                                }
                            });
                        }
                        calculateProductPrice(detailView, true);
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.validateCartQuantity = function(event){
                        return CCRZ.util.isValidNumericInput(event);
                    };
                    detailView.onProductQuantityChange = function(event){
                        UTIL.showLoader();
                        let _this = this;
                        let type = event.currentTarget.dataset.type, min = (event.currentTarget.dataset.min?parseInt(event.currentTarget.dataset.min):0);
                        var quantity = 0, cartQuantity = (_this.model.attributes.product.prodBean.cartData?(_this.model.attributes.product.prodBean.cartData.prodCartQuantity?_this.model.attributes.product.prodBean.cartData.prodCartQuantity:0):0);
                        try{
                            quantity = parseInt($("#product_quantity").val());
                        }catch(err){
                        }
                        if(!quantity || quantity <= 0){
                            quantity = min;
                            $("#product_quantity").val(quantity);
                        } 
                        let baseQty = quantity;
                        if(type == 'inc'){
                            baseQty = (quantity/min) + 1;
                            baseQty = baseQty * min;
                        } else if(type == 'dec'){
                            baseQty = (quantity/min) - 1;
                            baseQty = (baseQty < 1?(1 * min):(baseQty * min));
                        }
                        quantity = baseQty;
                        $("#product_quantity").val(quantity);
                        detailView.model.set('quantity', quantity);
                        calculateProductPrice(detailView, true);
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    
                    detailView.clickedOnAddToCart = function(e){
                        let _this = this;
                        var buttonclicked = $(e.target).attr("class");
                        UTIL.showLoader();
                        if(CCRZ.pagevars.isNonAccredited || (!CCRZ.pagevars.isNonAccredited && CCRZ.pagevars.isCredit) || CCRZ.pagevars.isGuest){
                            if(isCotermingChecked(detailView)){
                                var quantity = detailView.model.get('quantity'), frequencyTermId = detailView.model.get('frequencyTermId'), frequencyTerm = detailView.model.get('frequencyTerm'), parentSFID = detailView.model.attributes.product.prodBean.sfid;
                                let products = [], sku = detailView.model.attributes.product.prodBean.sku, isSubsc = detailView.model.attributes.product.prodBean.isSubscriptionAvailable, subTermId = null;
                                frequencyTerm = ((typeof frequencyTerm == 'undefined' || frequencyTerm == '')?'Yearly':frequencyTerm);
                                let ProductType = detailView.model.attributes.product.prodBean.ProductType, plItemId = '';
                                detailView.model.attributes.subProdTerms.forEach(function(spt){
                                    if(spt.sfid == frequencyTermId){
                                        plItemId = spt.priceListItemSFID;
                                    }
                                });
                                if(ProductType == "Aggregated"){
                                    let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                                    if(compositeProds && compositeProds.length > 0){
                                        compositeProds.forEach(function(prod){
                                            if(prod.isChecked){
                                                sku = prod.componentR.SKU;
                                            }
                                        });
                                    }
                                }
                                let productPrice = CCRZ.productDetailModel.attributes.productPrice;
                                let productData = {
                                    "sku": sku,
                                    "quantity": quantity,
                                    "subTermId" : frequencyTermId,
                                    "price" : productPrice + '',
                                    "subTotal" : productPrice + '',
                                    "parentSFID" : null,
                                    "isMain" : true,
                                    "tierPriced": detailView.model.attributes.product.prodBean.tierPriced,
                                    "startDate" :  UTIL.formatDate(detailView.model.attributes.startDate, 'mm/dd/yyyy'),
                                    "isReprint" : detailView.model.get('isReprint'),
                                    "category" : detailView.model.get('selectedCategory'),
                                    "subCategory" : detailView.model.get('selectedSubCategory'),
                                    "plItemId" : plItemId
                                };
                                if(detailView.model.get('isReprint')){
                                    productData['pubDate'] = detailView.model.get('pubdate');
                                    productData['media'] = detailView.model.get('mediaURI');
                                    productData['media512'] = detailView.model.get('media512URI');
                                    productData['extSKU'] = detailView.model.get('CIMAGEID') + '';
                                } else {
                                    productData['extSKU'] = '';
                                    productData['category'] = '';
                                    productData['subCategory'] = '';
                                }
                                products.push(productData);
                                if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                                    detailView.model.attributes.product.prodBean.compositeProductsS.forEach(function(product){
                                        if(product.quantity > 0){
                                            products.push({
                                                "sku": product.componentR.SKU,
                                                "quantity": product.quantity,
                                                "parentSku" : sku
                                            });
                                        }
                                    });
                                }
                                if(detailView.model.attributes.relatedProducts.Accessories){
                                    let relAccessories = detailView.model.attributes.relatedProducts.Accessories;
                                    if(relAccessories && relAccessories.length > 0){
                                        relAccessories.forEach(function(rel){
                                            if(rel.prodBean.isChecked){
                                                let productRelData = {
                                                    "sku": null,
                                                    "quantity": quantity,
                                                    "parentSFID": parentSFID,
                                                    "subTermId" : null,
                                                    "isMain" : false
                                                };
                                                if(rel.prodBean.compositeProductsS){
                                                    rel.prodBean.compositeProductsS.forEach(function(compositeProduct){
                                                        if(compositeProduct.isChecked){
                                                            productRelData.sku = compositeProduct.componentR.SKU;
                                                        }
                                                    });
                                                } else {
                                                    productRelData.sku = rel.prodBean.sku;
                                                }
                                                if(rel.prodBean.isSubscriptionAvailable && rel.subProdTerms && rel.subProdTerms.length > 0){
                                                    rel.subProdTerms.forEach(function(relSPTRec){
                                                        if(relSPTRec.installmentFrequencyUOM == frequencyTerm){
                                                            productRelData['subTermId'] = relSPTRec.sfid;
                                                        }
                                                    });
                                                }
                                                products.push(productRelData);
                                            }
                                        });
                                    }
                                }
                                let reqData = {
                                    "cartEncId": CCRZ.pagevars.currentCartID,
                                    "products": products,
                                    "currentUserCurrency" : CCRZ.pagevars.remoteContext.userIsoCode
                                }
                                if(quantity && quantity > 0){
                                    CCRZ.remoteActions.pdpRemoting.className = 'DCMB2B_pdp_Controller';
                                    CCRZ.remoteActions.pdpRemoting.addToCart(JSON.stringify(reqData),function(res,event){
                                        if(res && res.success && res.data && res.data.cartEncId){
                                            if(buttonclicked.indexOf("buy_now_button") >= 0){
                                                window.open(UTIL.getNavigateURL('cart', {'cartId': res.data.cartEncId}), '_self');
                                            } else {
                                                if(res.data.cartData){
                                                    CCRZ.productDetailModel.attributes.product.prodBean.cartData = res.data.cartData;
                                                }
                                                if(res.data.cartEncId){
                                                    try{
                                                        CCRZ.pagevars.currentCartID = res.data.cartEncId;
                                                        CCRZ.pagevars.queryParams['cartId'] = res.data.cartEncId;  
                                                        CCRZ.pubSub.trigger('cartChange', res.data.cartEncId);
                                                    }catch(err){}
                                                }
                                                if(CCRZ.pagevars.currentCartID && CCRZ.pagevars.currentCartID.trim().length > 0){
                                                    setTimeout(function(){
                                                        _this.render();
                                                    }, 2000);
                                                } else {
                                                    UTIL.hideLoader();
                                                }
                                                $('#sidebar').addClass('active');
                                                $('.sidebarMiniCart').removeClass('hide');
                                                $('#sidebarBackdrop').removeClass('hide');
                                            }
                                        } else if(res && !res.success && res.data.isSubscAvailable){
                                            console.log('Error adding product to cart');
                                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-PDP-Error", CCRZ.processPageLabelMap('KFB2B_pdp_productAvailableError').toString()));
                                            setTimeout(function(){
                                                $('.messagingSection-PDP-Error').css('display', 'none');
                                            }, 4000);
                                            UTIL.hideLoader();
                                        } else {
                                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-PDP-Error", CCRZ.processPageLabelMap('KFB2B_pdp_productAddError').toString()));
                                            setTimeout(function(){
                                                $('.messagingSection-PDP-Error').css('display', 'none');
                                            }, 4000);
                                            UTIL.hideLoader();
                                        }
                                    });
                                }else{
                                    UTIL.hideLoader();
                                }
                            } else {
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-PDP-Error", CCRZ.processPageLabelMap('KFB2B_pdp_productAvailableError').toString()));
                                setTimeout(function(){
                                    $('.messagingSection-PDP-Error').css('display', 'none');
                                }, 4000);
                                UTIL.hideLoader();
                            }
                        } else {
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-PDP-Error", CCRZ.processPageLabelMap('KFB2B_pdp_productAddAdminError').toString()));
                            setTimeout(function(){
                                $('.messagingSection-PDP-Error').css('display', 'none');
                            }, 4000);
                            UTIL.hideLoader();
                        }
                    };
                    detailView.clickedOnAddBoltOn = function(event){
                        let _this = this;
                        var target = $(event.target);
                        var parentSFID = event.currentTarget.dataset.sfid;
                        var className = event.target.classList;
                        var productSFID = '';
                        var reqData = {
                            "cartEncId": CCRZ.pagevars.currentCartID,
                            "quantity": 1,
                            "sellerId": CCRZ.productDetailModel.attributes.product.sellerID,
                            "sptSFID": null,
                            "currentUserCurrency" : CCRZ.pagevars.remoteContext.userIsoCode,
                            "tierPriced": false,
                            "isAdd": true,
                            "isAddOn": true, 
                            "mainProdSKU": CCRZ.pagevars.queryParams.sku,
                            "isFullQuantity": false,
                            "parentSFID": null
                        };
                        let isComposite = false;
                        if(className.length > 0){
                            for(let i = 0; i < className.length; i++){
                                if(className[i].indexOf("is-composite") >= 0){
                                    isComposite = true;
                                }
                            }
                        }
                        if(isComposite){
                            productSFID = $("#product_drop_"+parentSFID).val();
                            reqData['parentSFID'] = parentSFID;
                            reqData['sku'] = $("#selectedprod_sku_"+parentSFID).html();
                        }else{
                            productSFID = parentSFID+'';
                            reqData['sku'] = event.currentTarget.dataset.sku;
                        }
                        reqData['productSFID'] = productSFID;
                        UTIL.showLoader();
                        CCRZ.remoteActions.pdpRemoting.className = 'DCMB2B_pdp_Controller';
                        CCRZ.remoteActions.pdpRemoting.addToCart(JSON.stringify(reqData),function(res,event){
                            if(res && res.data && res.data.cartData && res.data.cartInfo && res.data.cartInfo.cartList.length){
                                CCRZ.productDetailModel.attributes.product.prodBean.cartData = res.data.cartData;
                                CCRZ.headerView.updateCart(res.data.cartInfo);
                            } else {
                                UTIL.hideLoader();
                            }
                            if(!CCRZ.pagevars.currentCartID || CCRZ.pagevars.currentCartID.trim().length <= 0){
                                try{
                                    CCRZ.pagevars.currentCartID = res.data.cartEncId;
                                    CCRZ.pagevars.queryParams['cartId'] = res.data.cartEncId;
                                }catch(err){}
                            }
                            if(CCRZ.pagevars.currentCartID && CCRZ.pagevars.currentCartID.trim().length > 0){
                                _this.render();
                                setTimeout(() => {
                                    runDefaultJsFunctions();
                                }, 500);
                            } else {
                                window.open(UTIL.getNavigateURL('pdp', {'sku': CCRZ.pagevars.queryParams.sku, 'cartID': CCRZ.pagevars.currentCartID.trim()}), '_self');
                            }
                        });
                    };
                    detailView.onCompositeProductChange = function(event){
                        let _this = this;
                        var parentSFID = event.currentTarget.dataset.parentsfid;
                        var selectedProdId = event.currentTarget.value;
                        var relatedList = _this.model.attributes.relatedProducts;
                        if(relatedList && relatedList.Accessories && relatedList.Accessories.length > 0){
                            relatedList.Accessories.forEach(function(accessory){
                                if(accessory.prodBean.ProductType == 'Aggregated' && accessory.prodBean.sfid == parentSFID){
                                    accessory.prodBean.compositeProductsS.forEach(function(composite){
                                        composite.isChecked = (composite.componentR.sfid == selectedProdId)?true:false;
                                    });
                                }
                            });
                            calculateProductPrice(detailView, true);
                            setTimeout(() => {
                                detailView.render();
                            }, 500);
                        }
                    };
                    detailView.renderDesktop = function(){
                        var v = this;
                        v.$el.html('');
                        $(CCRZ.uiProperties.productDetailView.desktop.right.selector).html('');
                        this.setElement($(CCRZ.uiProperties.productDetailView.desktop.main.selector));
                        v.$el.html(v.templateDesktop(v.model.toJSON()));
                        /*$( "#datePickerPDP" ).datepicker({ 
                            minDate: v.model.get('minDate'),
                            dateFormat: "mm/dd/yy",
                            defaultDate: +(v.model.get('minDate')),
                            showOn: "button",
                            buttonImage: "https://cdn4.iconfinder.com/data/icons/marketing-and-digital-marketing/32/business_marketing_advertising_event_calendar-21-512.png",
                            buttonImageOnly: true,
                            buttonText: "Select date",
                            beforeShowDay: $.datepicker.noWeekends
                        });
                        $( "#datePickerPDP" ).datepicker('setDate', v.model.get('startDate'));*/
                        runDefaultJsFunctions();
                        //$('#avgRating').rateit({ max: 5, step: 1});
                        this.doCarousel();
                        this.initValidationDesktop('#newCustomerForm');
                        this.initValidationDesktop('#callToActionForm');
                        CCRZ.promoView.render();
                        setTimeout(function(){ 
                            UTIL.hideLoader();
                            if((detailView.model.get('isPaymentError') || !detailView.model.get('isSubCatAvailable')) && !detailView.model.get('isNASelection')){
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-PDP-Error", 'Selected Product Variation is not available, please check later!'));
                            }
                        }, loaderTimeout);
                    };
                    detailView.delegateEvents();
                    isRefreshed = true;
                    if(isReprint){
                        detailView.model.set('isRendered', true);
                            let searchText = CCRZ.pagevars.queryParams.reprintId;
                            let reqData = {
                                'searchText': searchText,
                                'type': 'search',
                                'sortType': '-pubdate',
                                'UD_C64_1' : '1.0 Approved for Publication',
                                'isPDP' : true,
                                'offset': '0',
                                'pageSize': '100',
                                'productSKU' : detailView.model.attributes.product.prodBean.sku
                            }
                            CCRZ.remoteModel.merlinOneSearch(JSON.stringify(reqData), function(response, event){
                                if(response && response.data && response.data.products && response.data.products.length > 0){
                                    for(let i = 0; i < response.data.products.length;i++){
                                        for(let key in  response.data.products[i]){
                                            if(key == 'THUMBWEB'){
                                                detailView.model.set('mediaURI', UTIL.parseImage(response.data.products[i][key]));
                                            } else if(key == 'THUMB512'){
                                                detailView.model.set('media512URI', UTIL.parseImage(response.data.products[i][key]));
                                            } else if(key == 'PUBDATE'){
                                                detailView.model.set('pubdate', UTIL.formatDate(new Date(response.data.products[i][key]), 'mm/dd/yyyy'));
                                            } else {
                                                detailView.model.set(key, response.data.products[i][key]);
                                            }
                                        }
                                    }
                                }
                                if(CCRZ.pagevars.reprintCategory){
                                    detailView.model.set('reprintCategory', CCRZ.pagevars.reprintCategory);
                                    detailView.model.set('selectedCategory', "");
                                }
                                if(CCRZ.pagevars.reprintSubCatMap){
                                    detailView.model.set('reprintSubCatMap', CCRZ.pagevars.reprintSubCatMap);
                                    detailView.model.set('reprintSubCategory', "");
                                    detailView.model.set('selectedSubCategory', []);
                                    detailView.model.set('isNASelection', true);
                                    subCategoryPriceUpdate(detailView, "");
                                }
                            });
                    } else {
                        detailView.model.set('isRendered', true);
                        detailView.model.set('reprintCategory', []);
                        detailView.model.set('reprintSubCatMap', {});
                        let reqData = [
                            { "name": 'sundayCirculation', "objectName": 'Lead', "fieldName": 'KFB2B_Sunday_Circulation__c' },
                            { "name": 'dailyCirculation', "objectName": 'Lead', "fieldName": 'KFB2B_Daily_Circulation__c' },
                            { "name": 'monthlyVisitors', "objectName": 'Lead', "fieldName": 'KFB2B_Monthly_Unique_Visitors_Digital__c' }
                        ];
                        CCRZ.remoteModel.getInitDataPDP(JSON.stringify(reqData), function(res, evt){
                            if(res && res.success && res.data){
                                if(res.data.account){
                                    CCRZ.pagevars['isNonAccredited'] = res.data.account.KFB2B_Is_Non_Accredited__c;
                                }
                                reqData.forEach(function(item){
                                    if(res.data[item.name]){
                                        detailView.model.set(item.name, res.data[item.name]);
                                    }
                                });
                            } else {
                                // Error handling
                            }
                            detailView.render();
                        });
                    }
                } else {
                    UTIL.hideLoader();
                }
            });

            // Check if the items are co-termed 
            function isCotermingChecked(detailView){
                let cartItems = detailView.model.get('cartItems'), currentProd = detailView.model.attributes, isChecked = true;
                if(cartItems && cartItems.attributes.cartItems && cartItems.attributes.cartItems.length > 0){
                    cartItems.attributes.cartItems.forEach(function(item){
                        if(currentProd.product.prodBean.isSubscriptionAvailable == item.showSubProdTerm
                            && item.product.Id == currentProd.product.prodBean.sfid 
                            && item.subProdterm == currentProd.frequencyTermId
                            && (!isReprint || (isReprint && (currentProd.CIMAGEID == item.extSKU) 
                            && detailView.model.get('selectedCategory') == item.KFB2BReprintCategory
                            && detailView.model.get('selectedSubCategory') == item.KFB2BReprintSubCategory))){
                                isChecked = false;
                        }
                    });
                }
                return isChecked;
            }

            // Update Sub-categorySelection With price 
            function subCategoryPriceUpdate(detailView, subCatName){
                let selectedCategory = detailView.model.get('selectedCategory'), subProdTerms = detailView.model.get('subProdTerms'), isSubCatAvailable = false;
                if(subProdTerms && subProdTerms.length > 0 && subCatName != ""){
                    subProdTerms.forEach(function(spt){
                        if(spt.KFB2BSptType == 'Reprint' && !_.isUndefined(spt.reprintPricing) && spt.reprintPricing.length > 0){
                            spt.reprintPricing.forEach(function(category){
                                if(selectedCategory == category.name){
                                    if(typeof category.value == 'object' && !_.isUndefined(category.value) && category.value.length > 0){
                                        category.value.forEach(function(subCat){
                                            if(subCatName == subCat.name){
                                                detailView.model.set('productPrice', subCat.value);
                                                detailView.model.set('displayName', UTIL.formatCurrency(subCat.value));
                                                detailView.model.set('frequencyTermId', spt.sfid);
                                            }
                                        });
                                        isSubCatAvailable = true;
                                    }
                                }
                            });
                        }
                    });
                }
                detailView.model.set('isSubCatAvailable', isSubCatAvailable);
                detailView.render();
            }
            // Set authors and characters for tab section
            function setTabSectionData(detailView){
                let prodBean = detailView.model.attributes.product.prodBean, authorList = [], characterList = [];
                if(prodBean){
                    for(let i = 0; i < 4; i++){
                        if(typeof prodBean['KFB2BAUTH' + i + 'FNAME'] != 'undefined'){
                            authorList.push({
                                'firstName': prodBean['KFB2BAUTH' + i + 'FNAME'],
                                'lastName' : prodBean['KFB2BAUTH' + i + 'LNAME'],
                                'imageURI' : prodBean['KFB2BAUTH' + i + 'IMAGEURL'],
                                'bio' : prodBean['KFB2BAUTH' + i + 'BIO'],
                                'seq' : prodBean['KFB2BAUTH' + i + 'SEQ']
                            });
                        }
                    }
                    for(let i = 0; i < 8; i++){
                        if(typeof prodBean['KFB2BCHARACTER' + i + 'NAME'] != 'undefined'){
                            characterList.push({
                                'name': prodBean['KFB2BCHARACTER' + i + 'NAME'],
                                'imageURI' : prodBean['KFB2BCHARACTER' + i + 'IMAGEURL'],
                                'bio' : prodBean['KFB2BCHARACTER' + i + 'BIO'],
                                'seq' : prodBean['KFB2BCHARACTER' + i + 'SEQ']
                            });
                        }
                    }
                    if(authorList.length > 0){
                        authorList = _.sortBy(authorList, function(author) { return author.seq; });
                    }
                    if(characterList.length > 0){
                        characterList = _.sortBy(characterList, function(char) { return char.seq; });
                    }
                    detailView.model.set('authorList', authorList);
                    detailView.model.set('characterList', characterList);
                }
            }
            //Calculate kits and dynamic kits 
            function calculateBundlePrice(detailView){
                let productPrice = 0, frequencyTermId = detailView.model.get('frequencyTermId');
                detailView.model.attributes.product.prodBean.compositeProductsS.forEach(function(product){
                    if(product.quantity > 0){
                        product.componentR.tierList.forEach(function(priceList, index){
                            if(index == 0){
                                productPrice += priceList.listPrice * product.quantity;
                            }
                        });
                    }
                });
                if(detailView.model.attributes.subProdTerms && detailView.model.attributes.subProdTerms.length > 0){
                    detailView.model.attributes.subProdTerms.forEach(function(spt){
                        if(frequencyTermId != '' && spt.sfid == frequencyTermId){
                            productPrice = (productPrice/100) * spt.upfrontPricePercentage;
                        }
                    });
                }
                detailView.model.set('productPrice', productPrice);
            }
            // Calculate Normal, Subscription, Tier-Priced and Aggregate products
            function calculateProductPrice(detailView, isChange){
                let addOnPrice = 0, productPrice = 0, quantity = detailView.model.get('quantity'), frequencyTermId = detailView.model.get('frequencyTermId'), frequencyTerm = detailView.model.get('frequencyTerm');
                if(detailView.model.attributes.product.prodBean.DCMB2BIsTrialProduct){
                    frequencyTermId = (detailView.model.attributes.subProdTerms?detailView.model.attributes.subProdTerms[0].sfid:'');
                }
                if(!isChange){
                    if(detailView.model.attributes.relatedProducts.Accessories && detailView.model.attributes.relatedProducts.Accessories.length > 0){
                        detailView.model.attributes.relatedProducts.Accessories.forEach(function(related){
                            let relProductType = related.prodBean.ProductType;
                            if(relProductType == "Aggregated"){
                                let compositeProds = related.prodBean.compositeProductsS;
                                if(compositeProds && compositeProds.length > 0){
                                    compositeProds.forEach(function(prod, index){
                                        prod['isChecked'] = (index == 0?true:false);
                                    });
                                }
                            }
                        });
                    }
                }
                let monthlyPrice = 0, yearlyPrice = 0;
                if(detailView.model.attributes.product.prodBean.ERelatedProductsS && detailView.model.attributes.product.prodBean.ERelatedProductsS.length > 0){
                    detailView.model.attributes.product.prodBean.ERelatedProductsS.forEach(function(relatedItem){
                        if(relatedItem.relatedProductType == 'Accessories'){
                            if(detailView.model.attributes.relatedProducts.Accessories && detailView.model.attributes.relatedProducts.Accessories.length > 0){
                                detailView.model.attributes.relatedProducts.Accessories.forEach(function(related){
                                    if(relatedItem.relatedProduct == related.prodBean.sfid){
                                        related.prodBean['DCMRequired'] = relatedItem.DCMRequired;
                                        if(!isChange){
                                            related.prodBean['isChecked'] = relatedItem.DCMRequired;
                                        }
                                        if(related.prodBean.isSubscriptionAvailable){
                                            if(related.subProdTerms && related.subProdTerms.length > 0){
                                                related.subProdTerms.forEach(function(spt){
                                                    if(spt.installmentFrequencyUOM == frequencyTerm && related.prodBean.isChecked){
                                                        addOnPrice += (spt.productPrice);
                                                    }
                                                });
                                            }
                                        } else {
                                            if(related.prodBean.ProductType == 'Aggregated' && related.prodBean.isChecked){
                                                let compositeProds = related.prodBean.compositeProductsS;
                                                if(compositeProds && compositeProds.length > 0){
                                                    compositeProds.forEach(function(prod){
                                                        if(prod.isChecked){
                                                            prod.componentR.tierList.forEach(function(priceList){
                                                                addOnPrice += priceList.listPrice;
                                                            });
                                                        }
                                                    });
                                                }
                                            } else if(related.prodBean.isChecked){
                                                addOnPrice += related.prodBean.price;
                                            }
                                        }
                                    }
                                });
                            }
                        }
                        
                    });
                }
                let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                if(ProductType == "Aggregated"){
                    let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                    if(compositeProds && compositeProds.length > 0){
                        compositeProds.forEach(function(prod){
                            if(prod.isChecked){
                                prod.componentR.tierList.forEach(function(priceList){
                                    productPrice = priceList.listPrice;
                                });
                            }
                        });
                    }
                }
                if(detailView.model.attributes.product.prodBean.isSubscriptionAvailable){
                    if(detailView.model.attributes.subProdTerms && detailView.model.attributes.subProdTerms.length){
                        detailView.model.attributes.subProdTerms.forEach(function(spt){
                            if(spt.sfid == frequencyTermId){
                                productPrice = (spt.productPrice);
                            } else if(spt.CC_NO_SUBSCRIPTION){
                                productPrice = spt.productPrice;
                            }
                        });
                    }
                } else if(ProductType == 'Product'){
                    productPrice = detailView.model.attributes.product.prodBean.price;
                }
                detailView.model.set('productPrice', productPrice);
                detailView.model.set('displayName', UTIL.formatCurrency(productPrice));
                detailView.model.set('addOnPrice', addOnPrice);
            }
        
        }
            
    }
    
});

